#include <iostream>
using namespace std;

int len(long long int T[200000])
{
	for(int i=0;i>-1;i++)
	{
		if(T[i]>9000000000||T[i]<=0)
			return i;
	}
}


int f(long long int T[200000],int k)
{
	int i,j,m;
	long long int M[200000];
	long long int z=0;
	if(k==0)
	{
		for(i=0;i<len(T);i++)
		{
			z+=T[i];
		}
		return z;
	}
	else
	{
		for(i=0;i<len(T);i++)
		{
			for(j=i;j<len(T);j++)
			{ 
				for(m=0;m<=j-i;m++)
				{
					M[m]=T[m+i];
				}
				z+=f(M,k-1);
				for(int x=0;x<200000;x++)
				M[x]=-1;
			}
		}
	return z;
	}
	
}

int main() {
	long long int A[200000];
	int N,k;
	cin>>N;
	cin>>k;
	for(int i=0;i<N;i++)
	cin>>A[i];
	cout<<f(A,k)%1000000007;
	return 0;
}